<?php
namespace Teknisa\PLA\Controllers;

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Doctrine\DBAL\Connection;

class Pla90000PratoEquivalente extends \Teknisa\GER\Controllers\TeknisaCrud {
	protected $dataSourceName;
	protected $parameterBagColumns;
	protected $crudService;
	protected $parameterBag;
	protected $service;
	protected $dataSourceManager;
	protected $connection;

	public function __construct($crudService, $parameterBag, $dataSourceManager, $environment, $Pla90000PratoEquivalenteService, $entityManager, $authController, $util, $libUtilities, $reportService, $connection){
		$this->crudService          			= $crudService;
        $this->parameterBag         			= $parameterBag;
        $this->dataSourceManager    			= $dataSourceManager;
        $this->environment          			= $environment;
        $this->Pla90000PratoEquivalenteService	= $Pla90000PratoEquivalenteService;
        $this->entityManager        			= $entityManager;
        $this->authController       			= $authController;
        $this->util                 			= $util;
        $this->libUtilities         			= $libUtilities;
        $this->reportService        			= $reportService;
        $this->connection						= $connection;
	}

	public function retornaPratoEquivalente(DTO\Request $request, DTO\Response $response){
		$rows = $request->getRow();
		$nrEquiporato = $rows['NREQUIPRATO'];
        $retornoDoPratoEquivalente = $this->Pla90000PratoEquivalenteService->retornaPratoEquivalente($nrEquiporato);
    	$response->addDataSet(new Dataset('retornoDoPratoEquivalente', array($retornoDoPratoEquivalente)));
		
	}
	
	public function salvaPratoPrincipal(DTO\Request $request, DTO\Response $response){
		try {
			
			$rows = $request->getRow();
			$this->Pla90000PratoEquivalenteService->insertPratoPrincipal($rows);
		
		}catch(\Exception $e) {
			
			$response->addDataSet(new DataSet("errorInfo", array("erroSalvarPrato" => $e->getMessage())));
			$response->setError(new Error("erroSalvarPrato", 500));      
        }
    }
    
    public function salvaPratoEquivalente(DTO\Request $request, DTO\Response $response){
		try {
			
			$rows = $request->getRow();
			$this->Pla90000PratoEquivalenteService->insertPratoEquivalente($rows);
			
		}catch(\Exception $e) {
			
			$response->addDataSet(new DataSet("errorInfo", array("erroSalvarPrato" => $e->getMessage())));
			$response->setError(new Error("erroSalvarPrato", 500));      
        }
    }
    
    public function deletaPratoEquivalente(DTO\Request $request, DTO\Response $response){
		try {
			$rows = $request->getRow();
			$this->Pla90000PratoEquivalenteService->deletaPratoEquivalente($rows);
		}catch(\Exception $e) {
			$response->addDataSet(new DataSet("errorInfo", array("erroSalvarPrato" => $e->getMessage())));
			$response->setError(new Error("erroSalvarPrato", 500));      
        }
    }
    
    public function retornaPratoParaInclusao(DTO\Request $request, DTO\Response $response){
    	try {
			$rows = $request->getRow();
			$retornoDoPratoParaInclusao = $this->Pla90000PratoEquivalenteService->retornaPratoParaInclusao($rows);
    		$response->addDataSet(new Dataset('retornoDoPratoParaInclusao', array($retornoDoPratoParaInclusao)));
			
		}catch(\Exception $e) {
			$response->addDataSet(new DataSet("errorInfo", array("erroSalvarPrato" => $e->getMessage())));
			$response->setError(new Error("erroSalvarPrato", 500));      
        }
    }
    
    public function importaXlsPratoEquiv(DTO\Request $request, DTO\Response $response) {
    	try{
    		$this->entityManager->getConnection()->beginTransaction();
            $row = $request->getRow();
            $table = $this->Pla90000PratoEquivalenteService->readXls($row);
            $rows = $this->Pla90000PratoEquivalenteService->formatXls($table, $row['NMTABELA']);
            $this->entityManager->getConnection()->commit();
            $response->addDataSet(new DataSet('import', $rows));
        } catch(\Exception $e){
        	$this->entityManager->getConnection()->rollback();
            $errors = $e->getErrors();
            $response->addDataSet(new DataSet('errors', $errors));
            $response->setError(new Error($e->getMessage(), 500));
        } 
    }
}