<?php
namespace Teknisa\PLA\Modules\Parametros\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\GER\Services\CrudService;
use Doctrine\DBAL\Connection;
use Exception;

class Pla13300ItensParaRateioDeEfetivosControler extends \Teknisa\GER\Controllers\TeknisaCrud{
    
    protected $efetivosServiceRateio;
    protected $dataSourceName = "pla13300_itemrateioefet";

    public function __construct($crudService, $parameterBag, $entityManager, $efetivosServiceRateio) {
        $this->crudService       = $crudService;
        $this->parameterBag      = $parameterBag;
        $this->entityManager     = $entityManager;
        $this->efetivosServiceRateio   = $efetivosServiceRateio;
    }
    
    public function saveItemEfetivo(DTO\Request\Row $request, DTO\Response $response){
        try{
            $row = $request->getRow();
            $itemEfet["CDFILIAL"]            = $row["CDFILIAL"];
            $itemEfet["CDITEMRATEIOEFET"]    = $row["CDITEMRATEIOEFET"];
            $itemEfet["NMITEMRATEIOEFET"]    = $row["NMITEMRATEIOEFET"];
            $itemEfet["__is_new"]            = true;
            $itemEfet['__is_new_code']       = true;
            $itemEfet['__new_code_pk']       = $row['__new_code_pk'];
            $itemEfet['__table_pk']          = $row['__table_pk'];
            $itemEfet['__new_code_length']   = $row['__new_code_length'];

            $this->efetivosServiceRateio->saveItemEfetivo($itemEfet);
        }catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 1));
        }
    }
}